<!DOCTYPE html>

<html>

<head>
    {{ template "prelude" }}

    <script>
        async function load_error_plot() {
            const data = await load_time_series(
                "datasets_failed{source!=\"\"}",
                metric => metric["source"],
                true,
            );

            Plotly.newPlot(
                document.getElementById("errors"),
                data,
                {
                    title: "Harvester-Fehler",
                }
            );
        }

        async function load_duration_plot() {
            const data = await load_time_series(
                "last_harvest_duration{source!=\"\"} / 60",
                metric => metric["source"],
                true,
            );

            Plotly.newPlot(
                document.getElementById("duration"),
                data,
                {
                    title: "Harvester-Dauer",
                    yaxis: {
                        ticksuffix: "min",
                    },
                }
            );
        }

        async function load_transmitted_plot() {
            const data = await load_time_series(
                "datasets_transmitted{source!=\"\"}",
                metric => metric["source"],
                true,
            );

            Plotly.newPlot(
                document.getElementById("transmitted_datasets"),
                data,
                {
                    title: "Übertragene Datensätze",
                }
            );
        }

        async function load_transmission_rate() {
            const data = await load_time_series(
                "datasets_transmitted{source!=\"\"} / last_harvest_duration{source!=\"\"} * 60",
                metric => metric["source"],
                true,
            );

            Plotly.newPlot(
                document.getElementById("transmission_rate"),
                data,
                {
                    title: "Übertragungsrate",
                    yaxis: {
                        ticksuffix: "/min",
                    },
                }
            );
        }

        async function load_harvests_table() {
            const load_harvests = load_values("harvests{job=\"metadaten\"}");
            const load_failed_harvests = load_values("failed_harvests{job=\"metadaten\"}");
            const load_datasets = load_values("datasets{job=\"metadaten\"}");
            const load_last_harvest_duration = load_values("last_harvest_duration{job=\"metadaten\"}");

            const [
                harvests,
                failed_harvests,
                datasets,
                last_harvest_duration,
            ] = await Promise.all([
                load_harvests,
                load_failed_harvests,
                load_datasets,
                load_last_harvest_duration,
            ]);

            const failed_harvests_value = parseInt(failed_harvests["result"][0]["value"][1]);
            const failed_harvests_color = failed_harvests_value == 0 ? "green" : "red";

            var html = "<table>";

            html += `<tr><td>Harvests</td><td>${parseInt(harvests["result"][0]["value"][1])}</td></tr>`;
            html += `<tr><td>Failed harvests</td><td style="color: ${failed_harvests_color}">${failed_harvests_value}</td></tr>`;
            html += `<tr><td>Datasets</td><td>${parseInt(datasets["result"][0]["value"][1])}</td></tr>`;
            html += `<tr><td>Last harvest duration</td><td>${parseFloat(last_harvest_duration["result"][0]["value"][1]).toFixed()}s</td></tr>`;

            html += "</table>";

            document.getElementById("harvests_table").innerHTML = html;
        }

        async function load_umthes_table() {
            const load_fetched_tags = load_values("increase(umthes_fetched_tags{job=\"metadaten\"}[1d])");
            const load_fetched_tag_definitions = load_values("increase(umthes_fetched_tag_definitions{job=\"metadaten\"}[1d])");
            const load_searched_tags = load_values("increase(umthes_searched_tags{job=\"metadaten\"}[1d])");
            const load_tags = load_values("umthes_tags{job=\"metadaten\"}");
            const load_tag_definitions = load_values("umthes_tag_definitions{job=\"metadaten\"}");
            const load_search_results = load_values("umthes_search_results{job=\"metadaten\"}");

            const [
                fetched_tags,
                fetched_tag_definitions,
                searched_tags,
                tags,
                tag_definitions,
                search_results,
            ] = await Promise.all([
                load_fetched_tags,
                load_fetched_tag_definitions,
                load_searched_tags,
                load_tags,
                load_tag_definitions,
                load_search_results,
            ]);

            var html = "<table>";

            html += `<tr><td>Fetched tags</td><td>${parseFloat(fetched_tags["result"][0]["value"][1]).toFixed()}</td></tr>`;
            html += `<tr><td>Fetched tag definitions</td><td>${parseFloat(fetched_tag_definitions["result"][0]["value"][1]).toFixed()}</td></tr>`;
            html += `<tr><td>Searched tags</td><td>${parseFloat(searched_tags["result"][0]["value"][1]).toFixed()}</td></tr>`;
            html += `<tr><td>Tags</td><td>${parseInt(tags["result"][0]["value"][1])}</td></tr>`;
            html += `<tr><td>Tag definitions</td><td>${parseInt(tag_definitions["result"][0]["value"][1])}</td></tr>`;
            html += `<tr><td>Search results</td><td>${parseInt(search_results["result"][0]["value"][1])}</td></tr>`;

            html += "</table>";

            document.getElementById("umthes").innerHTML = html;
        }



        async function load_plots() {
            await Promise.all([
                load_error_plot(),
                load_duration_plot(),
                load_transmitted_plot(),
                load_transmission_rate(),
                load_harvests_table(),
                load_umthes_table(),
            ]);
        }

        window.onload = load_plots;
    </script>

    <title>Metadaten: Harvester</title>

    <style>
        body {
            font-family: sans-serif;
        }

        table {
            width: 100%;
        }

        td {
            width: 50%;
        }
    </style>
</head>

<body>
    <table>
        <tr>
            <td id="errors"></td>
            <td id="duration"></td>
        </tr>
        <tr>
            <td id="transmitted_datasets"></td>
            <td id="transmission_rate"></td>
        </tr>
        <tr>
            <td id="harvests_table"></td>
            <td id="umthes"></td>
        </tr>
    </table>
</body>

</html>